# -*- coding: utf-8 -*-
###############################################################################~!!~~!!!
#
# Copyright (c) 2010-2012, OPENTIA Group (<http://opentia.com>)
# The word "OPENTIA" is an European Community Trademark property of the Opentia Group
#
# @author: Opentia "Happy Hacking" Team
# @e-mail: consultoria@opentia·es
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###############################################################################~!!~~!!!
from osv import fields, osv
import decimal_precision as dp


class sale_order_line(osv.osv):

    _inherit = "sale.order.line"

    def _amount_line(self, cr, uid, ids, field_name, arg, context=None):
        tax_obj = self.pool.get('account.tax')
        cur_obj = self.pool.get('res.currency')
        res = {}
        if context is None:
            context = {}
        for line in self.browse(cr, uid, ids, context=context):
            price = line.price_unit * (1 - (line.discount or 0.0) / 100.0)
            taxes = tax_obj.compute_all(cr, uid, line.tax_id, price, line.product_uom_qty, line.order_id.partner_invoice_id.id, line.product_id, line.order_id.partner_id)
            cur = line.order_id.pricelist_id.currency_id
            sub = cur_obj.round(cr, uid, cur, taxes['total'])
            # Apply discounts
            sub = sub - (sub * line.d1 / 100)
            sub = sub - (sub * line.d2 / 100)
            res[line.id] = sub
        return res

    _columns = {
        'd1': fields.float('d1 (%)'),
        'd2': fields.float('d2 (%)'),
        'price_subtotal': fields.function(_amount_line, method=True, string='Subtotal', digits_compute= dp.get_precision('Sale Price')),
    }


    def wrp_product_id_change(self, *a, **kw):
        cr = a[0]
        uid = a[1]
        part_id = a[10]
        part_o = self.pool.get('res.partner')

        orig = self.product_id_change(*a, **kw)

        discs = part_o.read(cr, uid, part_id, ['disc1','disc2',])
        orig['value']['d1'] = discs['disc1']
        orig['value']['d2'] = discs['disc2']

        return orig

    _defaults = {
        'd1': 0.0,
        'd2': 0.0,
    }

sale_order_line()

class sale_order(osv.osv):

    _inherit = "sale.order"

    def button_dummy(self, cr, uid, ids, context=None):
        for o in self.browse(cr, uid, ids):
            for l in o.order_line:
                fiscal_position = o.partner_id.property_account_position
                taxes = self.pool.get('account.tax').browse(cr, uid,map(lambda x: x.id, l.product_id.taxes_id))
                fpos = fiscal_position or False
                taxes_id = self.pool.get('account.fiscal.position').map_tax(cr, uid, fpos, taxes)
                self.pool.get('sale.order.line').write(cr, uid, l.id, {'tax_id': [(6, 0, taxes_id)]})
        return True

sale_order()
